<?
	$_SERVER['REQUEST_URI']="/wordpress";
	$PATH="../";	
	include_once($PATH."include/envole.php");
	include_once($PATH."include/dbconf.php");
	include_once($PATH."include/mysql.php");
	$db1=new ps_db;
    $db1->dbname($config["dbhost"],"poshprofile",$config["dbpassword"],"poshprofile");

	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		$param=array('key'=>$argv[2]);
		//$_SERVER[ 'HTTP_HOST' ] = "amonecole23.ac-arno.fr";
		$_SERVER[ 'HTTP_HOST' ] = $config['host']; // Orléans
	}
	
	// Include général de wordpress
	include_once('../../wordpress/wp-load.php');
	require_wp_db();	
	include_once('../../wordpress/wp-admin/includes/user.php');

	// Permet d'ignorer les erreurs wordpress dans le cas plusieurs utilisateurs auraient le meme email
	define('WP_IMPORTING', true);

	// Include minimum pour posh-profil
	include_once($PATH."include/dbconf.php");
	include_once($PATH."include/mysql.php");
	include_once($PATH."include/admin.php");
	include_once($PATH."include/session.php");
	if($_SESSION['user_login']=="") $_SESSION['user_login']="UserCron";
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");

	global $wpdb;
	set_time_limit(600);
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}

	// Determine le role wordpress par rapport au parametre poshprofil
	function labelRole($idrole) {
	
		switch($idrole){
			
			case 0: $labelrole=""; break;
			case 1: $labelrole="subscriber"; break;
			case 2: $labelrole="contributor"; break;
			case 3: $labelrole="author"; break;
			case 4: $labelrole="editor"; break;
			case 5: $labelrole="administrator"; break;
		}
		
		return $labelrole;
	}
	
	// Determine en fonction du profil sso le profil wordpress
	function Profil($uid, $ENTProfil) {
		global $db1;
		global $config;
		
		$tbprofil=array('role' => '','sentry' => '');

		if($uid=="admin"){
			$tbProfil['role']	=labelRole($db1->f("perm_administrateur"));
			$tbProfil['sentry']	="personnels-administratifs";
		}
		else {
			switch($ENTProfil){
				case "eleve": 
					$tbProfil['role']	= labelRole($db1->f("perm_eleve"));
					$tbProfil['sentry']	= "eleves";
					break;
				
				case "responsable": 
					$tbProfil['role']	=labelRole($db1->f("perm_responsable"));
					$tbProfil['sentry']	="responsables";
					break;
								
				case "administratif":
					$tbProfil['role']	=labelRole($db1->f("perm_administratif"));
					$tbProfil['sentry']	="personnels-administratifs";
					break;

				case "enseignant":
					$tbProfil['role']	=labelRole($db1->f("perm_enseignant"));
					
					switch($uid){
						case "Visiteur":	$tbProfil['sentry'] ="";break;
						case "Meta_eleve":	$tbProfil['sentry']="eleves";break;
						case "Meta_parent":	$tbProfil['sentry']="responsables";break;
						case "Meta_prof":	$tbProfil['sentry']="enseignants";break;
						case "Meta_perdir":	$tbProfil['sentry']="personnels-administratifs";break;
						default : 			$tbProfil['sentry']="enseignants";
					}
					break;
				
				case "administrateur":
					$tbProfil['role']	=labelRole($db1->f("perm_administrateur"));
					$tbProfil['sentry']	="personnels-administratifs";
					break;
				
				case "visiteur":
				default : 
					$tbProfil['role']	=labelRole($db1->f("perm_visiteur"));
					$tbProfil['sentry']	="";
					break;
			}	
		}
        if (isset($config['uid_addadmin']))
        {
            if ($uid == $config['uid_addadmin']){
                $tbProfil['role'] = labelRole($db1->f("perm_administrateur"));
            }
        }
		
	    return $tbProfil;	
	}


	// rattachement d'un utilisateur à groupe wp-sentry d'un site
	function AtacheUserSentry($id,$groupe,$user_id) {
		global $wpdb;
		
	    // plugin groupe wp-sentry //
        if($groupe!=""){
            // construire le nom de la table wp_sentry associée au blog
            $blog_tb="wp_";
            if($id > 1) $blog_tb="wp_".$id."_";
			
            // recherche du groupe wp_sentry associé
	        $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
            $gid=$group->id;
			
            // si le groupe n'existe pas, on le génère
            if($gid=="") {
                $sql="INSERT INTO ".$blog_tb."sentry_groups(name) VALUES(\"".$groupe."\")";
                $wpdb->query($sql);
				
                $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
                $gid=$group->id;
            }

            // On affecte la personne au groupe wp_sentry
			if ($group->member_list!="") $group_members = explode(',', $group->member_list); 
			else $group_members = array();
		  
			if(!in_array($user_id, $group_members)) array_push($group_members,$user_id);
			$group->member_list=implode(',',$group_members);

			$sql="UPDATE ".$blog_tb."sentry_groups SET member_list=\"".$group->member_list."\" WHERE id=$gid";
			$wpdb->query($sql);	        
	    }				    
	}

	// ratachement d'un utilisateur à un site
	function AtacheUserBlog($id,$ds,$entryID,$role_notchange) {
		$uid		= ldap_get_values($ds,$entryID,'uid');
		$cn			= ldap_get_values($ds,$entryID,'cn');
		@$mail		= ldap_get_values($ds,$entryID,'mail');
		@$ENTprofil	= ldap_get_values($ds,$entryID,'ENTPersonProfils');
		$profil		= array('role' => '','sentry' => '');
		$profil		= Profil($uid[0],$ENTprofil[0]);

		if ($user=get_userdatabylogin($uid[0])){
			$user_id=$user->ID;
			
			if(is_user_member_of_blog( $user_id, $id ) AND !($role_notchange)){
				AfficheLigne("Utilisateur = $uid[0] = Ne pas modifier");
			}
			else {
				AfficheLigne("Utilisateur = $uid[0] = ".$profil['role']);
				add_user_to_blog( $id, $user_id, $profil['role'] );
				AtacheUserSentry($id,$profil['sentry'],$user_id);
			}
		}
	}	
	
	
	// detachement d'un utilisateur au groupe wp-sentry
	function DetacheUserSentry($id,$userid) {
		global $wpdb;
		
		// construire le nom de la table wp_sentry associée au blog
		$blog_tb="wp_";
		if($id > 1) $blog_tb="wp_".$id."_";
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."sentry_groups");
		foreach($groups as $group) {
			if ($group->member_list!="") {
				$gid=$group->id;
				$group_members = explode(',', $group->member_list); 
				
				if(in_array($userid,$group_members)) {
					$key = array_search($userid, $group_members);
				
					unset($group_members[$key]);
					$group->member_list=implode(',',$group_members);
					$sql="UPDATE ".$blog_tb."sentry_groups SET member_list='".$group->member_list."' WHERE id=$gid";
					$wpdb->query($sql);				
				}
			}
		}
	}
	
	// detachement des utilisateurs à un site
	function DetacheUserBlog($id,$ds,$ldapsearch) {	
		global $config;
		
		// Pour chaque utilisateur du blog on vérifie que l'utilisateur existe toujours
		$blogusers=get_users("blog_id=$id");
		foreach ($blogusers as $user) {
							
			// Ne jamais enlever admin
			if($user->user_login=="admin") {
				AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
			}
			else {
				// S'il n'existe pas on le supprime et on attache ses articles à l'utilisateur admin
				$res = ldap_search($ds,$config['LDAPracine'],str_replace("%userid%",$user->user_login,$ldapsearch));
				if($entryID=ldap_first_entry($ds,$res))
					AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
				else {
					$user_id=$user->ID;
					AfficheLigne("Utilisateur = ".$user->user_login." = supprimé");;
					
					// Détacher l'utilisateur du site
					remove_user_from_blog($user_id,$id,$admin_id);		
					DetacheUserSentry($id,$user_id);						
				}
			}
		}
	}
	

	function my_get_blog_list( $start = 0, $num = 10, $deprecated = '' ) {
		_deprecated_function( __FUNCTION__, '3.0' );

		global $wpdb;
		$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );
		
		foreach ( (array) $blogs as $details ) {
			$blog_list[ $details['blog_id'] ] = $details;
			$blog_list[ $details['blog_id'] ]['postcount'] = $wpdb->get_var( "SELECT COUNT(ID) FROM " . $wpdb->get_blog_prefix( $details['blog_id'] ). "posts WHERE post_status='publish' AND post_type='post'" );
		}
		unset( $blogs );
		$blogs = $blog_list;

		if ( false == is_array( $blogs ) )
			return array();

		if ( $num == 'all' )
			return array_slice( $blogs, $start, count( $blogs ) );
		else
			return array_slice( $blogs, $start, $num );
	}	
//Orléans	
	function recupClasseNiveau($ds){
		global $config;
		
		// Récupération des éléves par classes pour créer les groupes des responsables par classe ex responsable_3e1
		$res = ldap_search($ds,$config['LDAPracine'],"type=Classe");	
		$groupeNiveau=array();
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{		
			$cn		= ldap_get_values($ds,$entryID,'cn');
			$niveau	= ldap_get_values($ds,$entryID,'niveau');
			if ($niveau[0]!=""){
				$groupeNiveau[$cn[0]]=$niveau[0];
			}
		}
		return $groupeNiveau;
	}

	function recupEleve($ds,$uid){
		global $config;
		
		// Récupération des éléves par classes pour créer les groupes des responsables par classe ex responsables_3eme/responsables_4eme ...
		$tabEleveNiveau=array();

		$res = ldap_search($ds,$config['LDAPracine'],"uid={$uid}");	
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{		
			$classe		= ldap_get_values($ds,$entryID,'divcod');
			$mef		= ldap_get_values($ds,$entryID,'ENTEleveMEF');
			$tabEleveNiveau[$uid]['Divcod']=$classe[0];
			$tabEleveNiveau[$uid]['ENTEleveMEF']=$mef[0];
		}
		return $tabEleveNiveau;
	}
// fin Orléans

	// rattachement d'un utilisateur à groupe Buddypress et création du groupe buddypress si il n'existe pas
	function atacheUserBuddyPress($groupe, $userId) {
		global $wpdb;
		global $config;
		// On teste l'existence du groupe pour le creer si besoin
 		$group = $wpdb->get_row("SELECT name FROM wp_bp_groups WHERE name='" . addslashes($groupe) . "'");
		if ($group->name=="") {
			AfficheLigne("Création du groupe BuddyPress pour la classe '$groupe'");
			$wpdb->query("INSERT INTO wp_bp_groups (creator_id, name, slug, description, status, enable_forum, date_created, parent_id) VALUES ('1', '" . addslashes($groupe) . "', '" . addslashes($groupe) . "', 'Classe de " . addslashes($groupe) . "', 'private', 0, NOW(), 0)");
		}
		// Recherche de l'id du groupe buddypress créé ou existant
		$group = $wpdb->get_row("SELECT id FROM wp_bp_groups WHERE name='" . addslashes($groupe) . "'");
                $idGrp = $group->id;
		// Là il y a un problème :
		if ($idGrp=="") AfficheLigne ("!!!!!!!! Erreur lecture id de groupe buddypress !!!!!!!");
		// Sinon on peut continuer
		else
		{
			// Mise à jour métadonnées du groupe si elle n'existe pas (cas d'un groupe fraichement créé)
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$idGrp' AND meta_key='invite_status'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($idGrp) . "', 'invite_status', 'admins')");
			// Ajout des admin du groupe si ils n'existent pas
			creerAdminBuddyPress ($idGrp, $groupe, 1, "admin");
			// Ajout admin2 si existe
			if (isset($config['uid_addadmin']) && $config['uid_addadmin']!="") {
				$lireId = $wpdb->get_row("SELECT ID FROM wp_users WHERE user_login='" . addslashes($config['uid_addadmin']) . "'");
				$idAdmin2 = $lireId->ID;
				if ($idAdmin2=="") AfficheLigne ("!!!!!!!! Erreur lecture user_login de admin2 (login=" . $config['uid_addadmin'] . ") !!!!!!!");
				else creerAdminBuddyPress ($idGrp, $groupe, $idAdmin2, $config['uid_addadmin']);

			}
			// Ajout des utilisateurs dans les groupes buddypress
			// On recherche le login correspondant à cet id
			$lireNom = $wpdb->get_row("SELECT user_login FROM wp_users WHERE ID='$userId'");
			$nomUser = $lireNom->user_login;
			if ($nomUser=="") AfficheLigne ("!!!!!!!! Erreur lecture user_login de l'utilisateur iduser=$userId !!!!!!!");
			else {
				// Vérifions si le membre n'est pas déjà enregistré
				$lireMembers = $wpdb->get_row("SELECT id FROM wp_bp_groups_members WHERE user_id='$userId' and group_id='$idGrp'");
				if ($lireMembers->id!="") AfficheLigne("Ajout d'un utilisateur dans le groupe buddypress '$groupe' : login='$nomUser' --> déjà existant");
				else {
					AfficheLigne("Ajout d'un utilisateur dans le groupe buddypress '$groupe' : login='$nomUser'");
					// Ajout à la table des membres du groupe
					$wpdb->query("INSERT INTO wp_bp_groups_members (group_id, user_id, inviter_id, is_admin, is_mod, user_title, date_modified, comments, is_confirmed, is_banned, invite_sent) VALUES ('" . addslashes($idGrp) . "', '" . $userId ."', '0', '0', '0', '', NOW(), '', '1', '0', '0')");
					// Mise à jour de la table wp_bp_activity pour l'utilisateur
					$wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $userId .", 'groups', 'joined_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomUser) . "/\" title=\"" . addslashes($nomUser) . "\">" . addslashes($nomUser) . "</a> a rejoint le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomUser) . "/', " . $idGrp . ", 0, NOW(), 1, 0, 0, 0)");
					// Mise à jour du nombre d'utilsateurs dans le groupe
					$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value+1 WHERE group_id='$idGrp' AND meta_key='total_member_count'"); 
					$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='$idGrp' AND meta_key='last_activity'"); 
					// Mise à jour nombre de groupes par utilisateursdans wp_usermeta (nombre de groupe de l'utilisateur)
					$meta = $wpdb->get_row("SELECT umeta_id FROM wp_usermeta WHERE user_id='" . $userId ."' AND meta_key='total_group_count'");
					$idMeta = $meta->umeta_id; 
					if ($idMeta!="") $wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value+1 WHERE umeta_id='" . $idMeta . "'");
					else $wpdb->query("INSERT INTO wp_usermeta (user_id, meta_key, meta_value) VALUES (" . $userId .", 'total_group_count', '1')");
					$wpdb->query("UPDATE wp_usermeta SET meta_value=NOW() WHERE user_id='$userId' AND meta_key='last_activity'"); 
				}				
			}
		}
         }

	// rattachement des admins au groupe buddypress créé si l'admin n'est pas déjà enregistré
	function creerAdminBuddyPress ($idGrp, $groupe, $idAdmin, $nomAdmin) {
		global $wpdb;
		global $config;
		// On va vérifier qu'il n'est pas déjà membre
		$lireMembers = $wpdb->get_row("SELECT id FROM wp_bp_groups_members WHERE user_id='$idAdmin' and group_id='$idGrp'");
		if ($lireMembers->id=="") {
			AfficheLigne("Création administrateur du groupe buddypress '$groupe' : login='$nomAdmin'");
			// Ajout à la table des membres du groupe
			$wpdb->query("INSERT INTO wp_bp_groups_members (group_id, user_id, inviter_id, is_admin, is_mod, user_title, date_modified, comments, is_confirmed, is_banned, invite_sent) VALUES ('" . addslashes($idGrp) . "', '" . $idAdmin ."', '0', '1', '0', 'Administration', NOW(), '', '1', '0', '0')");
			// Mise à jour de la table wp_bp_activity pour les admin
			if ($nomAdmin=="admin") $wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $idAdmin .", 'groups', 'created_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/\" title=\"" . addslashes($nomAdmin) . "\">" . addslashes($nomAdmin) . "</a> a créé le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/', " . $idGrp . ", 0, NOW(), 1, 0, 0, 0)");
			else $wpdb->query("INSERT INTO `wp_bp_activity` (`user_id`, `component`, `type`, `action`, `content`, `primary_link`, `item_id`, `secondary_item_id`, `date_recorded`, `hide_sitewide`, `mptt_left`, `mptt_right`, `is_spam`) VALUES (" . $idAdmin .", 'groups', 'joined_group', '<a href=\"https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/\" title=\"" . addslashes($nomAdmin) . "\">" . addslashes($nomAdmin) . "</a> a rejoint le groupe <a href=\"https://" . $config['host'] ."/wordpress/groupes/" . $groupe . "/\">" . $groupe . "</a>', '', 'https://" . $config['host'] ."/wordpress/membres/" . addslashes($nomAdmin) . "/', " . $idGrp . ", 0, NOW(), 1, 0, 0, 0)");
			// Mise à jour des métas données #1
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$idGrp' AND meta_key='total_member_count'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($idGrp) . "', 'total_member_count', '1')"); 
			else $wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value+1 WHERE group_id='$idGrp' AND meta_key='total_member_count'"); 
			// Mise à jour des métas données #2
			$r = $wpdb->get_row("SELECT id FROM wp_bp_groups_groupmeta WHERE group_id='$idGrp' AND meta_key='last_activity'");
			if ($r->id=="") $wpdb->query("INSERT INTO wp_bp_groups_groupmeta (group_id, meta_key, meta_value) VALUES ('" . addslashes($idGrp) . "', 'last_activity', NOW())"); 
			else $wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='$idGrp' AND meta_key='last_activity'"); 
			// Mise à jour nombre de groupes par utilisateur dans wp_usermeta 
			$meta = $wpdb->get_row("SELECT umeta_id FROM wp_usermeta WHERE user_id='" . $idAdmin ."' AND meta_key='total_group_count'");
			$idMeta = $meta->umeta_id; 
			if ($idMeta!="") $wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value+1 WHERE umeta_id='" . $idMeta . "'");
			else $wpdb->query("INSERT INTO wp_usermeta (user_id, meta_key, meta_value) VALUES (" . $idAdmin .", 'total_group_count', '1')");
		}
	}


	// Détachement d'un utilisateur du groupe buddypress
	function detacheUserBuddyPress($userId) {
		global $wpdb;
		global $config;
		// On recherche le login correspondant à cet id
		$lireNom = $wpdb->get_row("SELECT user_login FROM wp_users WHERE ID='$userId'");
		$nomUser = $lireNom->user_login;
		if ($nomUser=="") AfficheLigne ("!!!!!!!! Erreur lecture user_login de l'utilisateur iduser=$userId !!!!!!!");
		else {
			// Vérifions si le membre n'est pas déjà enregistré
			$lireMembers = $wpdb->get_results("SELECT group_id FROM wp_bp_groups_members WHERE user_id='$userId'");
			if (!count($lireMembers)) AfficheLigne("L'utilisateur '$nomUser' n'est présent dans aucun groupe");
			else {
				AfficheLigne("Suppression de l'utilisateur '$nomUser' dans " . count($lireMembers) . " groupes buddypress");
				// On traite groupe par groupe
				for ($x=0 ; $x<count($lireMembers) ; $x++) {
					// Suppression de la table des membres de l'utilisateur
					$wpdb->query("DELETE FROM wp_bp_groups_members WHERE group_id='" . $lireMembers[$x]->group_id . "' AND user_id='$userId'");
					// Mise à jour de la table d'activité
					$wpdb->query("DELETE FROM `wp_bp_activity` WHERE user_id='$userId' AND item_id='" . $lireMembers[$x]->group_id . "' AND component='groups'");
					// Mise à jour des méta données du groupe
					$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=meta_value-1 WHERE group_id='" . $lireMembers[$x]->group_id . "' AND meta_key='total_member_count'"); 
					$wpdb->query("UPDATE wp_bp_groups_groupmeta SET meta_value=NOW() WHERE group_id='" . $lireMembers[$x]->group_id . "' AND meta_key='last_activity'"); 
					// Mise à jour des méta données utilisateur
					$wpdb->query("UPDATE wp_usermeta SET meta_value=meta_value-1 WHERE user_id='" . $userId ."' AND meta_key='total_group_count'");
					$wpdb->query("UPDATE wp_usermeta SET meta_value=NOW() WHERE user_id='$userId' AND meta_key='last_activity'"); 
				}
			}				
		}

	}

//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
    if (!$r) {
		AfficheLigne("Erreur authentification : impossible de se connecter à l'annuaire LDAP");
		die();
    }

	$groupeNiveau=recupClasseNiveau($ds);
	
	$blog_list = my_get_blog_list( 0, "all");
	asort($blog_list);
	foreach ($blog_list AS $blog) {
		AfficheTitre("SYNCHRONISATION SITE = ".$blog['path']);
		$id=$blog['blog_id'];
		
		$db1->query("SELECT * FROM admin_wordpress WHERE id=$id");
		if(!$db1->next_record()||!$db1->f("synchro_user"))
		{
			AfficheLigne("Synchronisation désactivée");
		}
		else 
		{
			switch($db1->f("idsynchro")) {
				// Synchronisation sur l'ensemble des utilisateurs
				case "-1":
			        $fgpurgefin=true;
			        
					// Vérifions que le blog est bien le principal
					$blogPrincipal = false;
					$reponse = $wpdb->get_row("SELECT path FROM wp_blogs WHERE blog_id='$id'");
					if (count($reponse)==1) if($reponse->path == "/wordpress/") $blogPrincipal = true;
					if ($blogPrincipal) {
 						AfficheLigneGras("Ce blog est le principal");
						AfficheLigne("");
						// Détection activation de buddypress : il faut utiliser les 2 méthodes en paralelle (???)
						$buddypressActif = false;
						// Méthode 1 : sur une fresh
						$reponse = $wpdb->get_row("SELECT meta_value FROM wp_sitemeta WHERE meta_key='active_sitewide_plugins'");
						if (count($reponse)==1) foreach (unserialize($reponse->meta_value) as $key => $value) if ($key == "buddypress/bp-loader.php") $buddypressActif = true;
						// méthode 2 : ensuite
						$reponse = $wpdb->get_row("SELECT option_value FROM wp_options WHERE option_name='active_plugins'");
						if (count($reponse)==1) foreach (unserialize($reponse->option_value) as $key => $value) if ($key == "buddypress/bp-loader.php") $buddypressActif = true;
						if ($buddypressActif) AfficheLigneGras("Buddypress : activé");
						else  AfficheLigneGras("Buddypress : désactivé");
						AfficheLigne("");
					}
	
					// sauvegarde de la table wp_sentry_groups pour pouvoir restaurer les groupes créés par l'établissement					
					$groups_save = $wpdb->get_results("SELECT * FROM wp_sentry_groups");

					// vidage de la table wp-sentry pour actualiser les groupes
					AfficheLigneGras("Vidage table wp_sentry_groups");
					$wpdb->query("TRUNCATE TABLE wp_sentry_groups");

					// création/maj de tous les groupes (principaux et autres)
					AfficheLigne("");
					AfficheLigneGras("Création des utilisateurs/groupes sur le site principal");
					
					$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=*)(objectclass=inetOrgPerson)(!(description=Computer)))");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{					
						$uid		= ldap_get_values($ds,$entryID,'uid');
						$cn			= ldap_get_values($ds,$entryID,'cn');
						@$mail		= ldap_get_values($ds,$entryID,'mail');
						@$ENTprofil	= ldap_get_values($ds,$entryID,'ENTPersonProfils');
						$pass		= "";
						$profil		= array('role' => '','sentry' => '');
						$profil		= Profil($uid[0],$ENTprofil[0]);
						@$regime	= ldap_get_values($ds,$entryID,'enteleveregime');
						@$classe	= ldap_get_values($ds,$entryID,'divcod');
												
						AfficheLigne("Utilisateur = $uid[0] = ".$profil['role']);
						// Création de l'utilisateur
						// la fonction  get_userdatabylogin est dans /var/www/html/wordpress/wp-includes/pluggable.php
						// s'il n'est pas dans la bd wordpress wp_users il est créé.
						if (!$user=get_userdatabylogin($uid[0])){
							$user_id = wp_create_user($uid[0], $pass[0], $mail[0]);	
						}
						else{
							$user_id=$user->ID;
						}
						
						// Modification de l'utilisateur
						// s'il est  dans la bd wordpress wp_users il est mis ajour.
						wp_update_user(array ('ID' => $user_id, 'user_email' => $mail[0]));
						add_user_to_blog( $id, $user_id, $profil['role'] );
						AtacheUserSentry($id,$profil['sentry'],$user_id);
								
						if ($ENTprofil[0]=="eleve")	{
							//rattachement des utilisaseurs au groupe regime de l'élève  : demi-pensionnaire/externe ...
							AtacheUserSentry($id,$regime[0],$user_id);
						}
						//rattachement de l'utilisaseur aux groupex profs-principaux/profs-principaux-3eme/profs-principaux-6eme ...
						if ($ENTprofil[0]=="enseignant") {
							if(!empty($classe[0])){
							AtacheUserSentry($id,"profs-principaux",$user_id);
							AtacheUserSentry($id,"profs-principaux-".$groupeNiveau[$classe[0]],$user_id);
							}
						}		
						
						if ($ENTprofil[0]=="responsable")	{
							// création des groupes responsables 3eme, 3e1, 3e2 ..., 4eme, 4e1, 4e2...
							$recupEleve=array();
							$eleve = ldap_get_values($ds,$entryID,'eleve');
							for ($i=0; $i < $eleve["count"]; $i++) {
								$recupEleve=recupEleve($ds,$eleve[$i]);
								$uid_eleve = $eleve[$i];
								$groupe_MEF = "responsables-".$recupEleve[$uid_eleve]['ENTEleveMEF'];
								$groupe_Divcod = "responsables-".$recupEleve[$uid_eleve]['Divcod'];
								AtacheUserSentry($id,$groupe_MEF,$user_id);
								AtacheUserSentry($id,$groupe_Divcod,$user_id);
							}
						}
					}
				
					// Les autres groupes enseignants/personnels-administratifs/profs-anglais/eleves-3eme/eleves-3e1/personnels-ADF
					$res = ldap_search($ds,$config['LDAPracine'],"(&(type=*)(memberUid=*))");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{			
						$cn				= ldap_get_values($ds,$entryID,'cn');
						$member			= ldap_get_values($ds,$entryID,'memberUid');
						$type   		= ldap_get_values($ds,$entryID,'type');
						$description	= ldap_get_values($ds,$entryID,'description');
						
						$nmgroup="";
						switch ($type[0]) {
							case "Base" 	: if ($cn[0]=="professeurs"){
												$nmgroup="enseignants";
											  }elseif ($cn[0]=="administratifs"){
												$nmgroup="personnels-administratifs";
											  }
											break;
							case "Matiere"	: $nmgroup="profs-".$cn[0];  		
											  break; // profs-anglais							
							case "Niveau"	: $nmgroup="eleves-".$cn[0];  		
											  break; //eleves-3eme ...
							case "Classe" 	: $nmgroup="eleves-".$cn[0];  		
											  break; // eleves-3e1
							case "Option" 	: $nmgroup="option-".$cn[0];
											  break;
							case "Service" 	: $nmgroup="personnels-".strtoupper($cn[0]);  	
											  break; // personnels-ADF							
							case "Equipe" 	: $nmgroup=str_replace("Equipe profs-","Equipe-profs-",$cn[0]); 
											  break; // profs-3e1
							case "Groupe"	: $nmgroup="groupe-".$description[0];  	
											  break;
							default			: $nmgroup="";
											  break;
						}					
						
						// Parcourt des utilisateurs membre du group LDAP pour créer le groupe profs-3eme
						for ($i=0; $i<(count($member)-1); $i++) {
							if(isset($member[$i])) {
								// On recherche l'utilisateur en cours
								$req="SELECT id FROM wp_users WHERE user_login=\"".$member[$i]."\"";
								$users = $wpdb->get_row($req);
								$iduser=$users->id;
								
								// Rattachement de l'utilisateur au groupe si ce n'est pas déjà le cas
								AtacheUserSentry($id,$nmgroup,$iduser);

								if ($type[0]=="Equipe"){
									// constitution des groups profs-niveau (profs-3eme)
									$long=strlen($cn[0]);
									$classe0=$cn[0];
									// détermination de la classe dans la chaine cn[0] qui contient profs-classe donc à partir de la position 6 jusqu'à la fin
									$classe=substr($cn[0],6,$long); 
									if($groupeNiveau[$classe]=="")
										AtacheUserSentry($id,"profs-sans-classe",$iduser);
									else
										AtacheUserSentry($id,"profs-".$groupeNiveau[$classe],$iduser);									
								}	

								// Traitements des groupes Buddypress : uniquement pour le blog principal
								if ($blogPrincipal && $buddypressActif) {
									// Classes et leurs élèves
									if ($type[0]=="Classe") atacheUserBuddyPress($cn[0], $iduser);
									if ($type[0]=="Equipe") atacheUserBuddyPress(str_replace("profs-", "", $cn[0]), $iduser);
								}
							}
						}						
					}		

				
					// Récupération de l'id de l'admin
					$user=get_userdatabylogin('admin');
					$admin_id=$user->ID;
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Suppression des utilisateurs obsolètes");
						
						// Pour chaque utilisateur du blog on vérifie que l'utilisateur existe toujours
						$blogusers=get_users("blog_id=$id");
						foreach ($blogusers as $user) {
							
							// S'il n'existe pas on le supprime et on attache ses articles à l'utilisateur admin
							$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=".$user->user_login.")(objectclass=inetOrgPerson)(!(description=Computer)))");
							if($entryID=ldap_first_entry($ds,$res))
								AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
							else {
								AfficheLigne("Utilisateur = ".$user->user_login." = supprimé");
								$user_id=$user->ID;
								
								// Traitements des utilisateurs Buddypress : uniquement pour le blog principal
								if ($blogPrincipal && $buddypressActif) detacheUserBuddyPress($user_id);

								// Détacher l'utilisateur du site
								wp_delete_user($user_id,$admin_id);
								
								// Suppression définitive
								$wpdb->query("DELETE FROM $wpdb->users WHERE ID = $id");
								$wpdb->query("DELETE FROM $wpdb->usermeta WHERE user_id = $id");
							}
						}
					}

					$groups_new = $wpdb->get_results("SELECT * FROM wp_sentry_groups");
					foreach($groups_save as $group_save) {
						$trouve=0;
						foreach($groups_new as $group_new) {
							if ($group_save->name == $group_new->name) {
								$trouve=1;								
							}
						}
						if(!$trouve){
							AfficheLigne("Groupe restauré : ".$group_save->name);																					
							// groupe à restaurer mais on vérifie si les membres existe tjs dans wp_users
							// si n'existe plus => le supprimer du groupe
							$members=explode(',',$group_save->member_list);
							$members2=$members;
							$nbMember=count($members2);
							for ($i=0;$i<$nbMember;$i++){
								if (!$userMember=get_userdata($members2[$i])){
									// user n'existe pas donc à supprimer des membres du groupe
									$key = array_search($members2[$i], $members);								
									unset($members[$key]);
								}
							}
							$group_save->member_list=implode(',',$members);							
							$sql="INSERT INTO wp_sentry_groups (id, name, member_list, member_of) VALUES (0, '".$group_save->name."', '".$group_save->member_list."', '".$group_save->member_of."')";
							$wpdb->query($sql);				
						}
					}							
				break;
				
				// Synchronisation sur les parents
				case 0:
					AfficheLigneGras("Rattachement des utilisateurs ".$db1->f("labelsynchro")." sur le site");
				
					$res = ldap_search($ds,$config['LDAPracine'],"ENTPersonProfils=responsable");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						AtacheUserBlog($id,$ds,$entryID,$db1->f("role_notchange"));
					}				

					// Ajouter quoi qu'il arrive l'utilisateur admin
					$res = ldap_search($ds,$config['LDAPracine'],"uid=admin");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						AtacheUserBlog($id,$ds,$entryID,$db1->f("role_notchange"));
					}
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Détacher les utilisateurs du site");
						DetacheUserBlog($id,$ds,"(&(uid=%userid%)(ENTPersonProfils=responsable))");
					}						
					
					break;
					
				// Synchronisation sur les autres groupes
				default:
					AfficheLigneGras("attachement des utilisateurs ".$db1->f("labelsynchro")." sur le site");

					$res = ldap_search($ds,$config['LDAPracine'],"(&(gidNumber=".$db1->f("idsynchro").")(type=*))");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						$cn			= ldap_get_values($ds,$entryID,'cn');						
						@$member	= ldap_get_values($ds,$entryID,'memberUid');

						for ($i=0; $i<count($member); $i++) {
							if($member[$i]!="") {
								$res2 = ldap_search($ds,$config['LDAPracine'],"uid=".$member[$i]);
								for ($entryID2=ldap_first_entry($ds,$res2);$entryID2!=false;$entryID2=ldap_next_entry($ds,$entryID2))
								{
									AtacheUserBlog($id,$ds,$entryID2,$db1->f("role_notchange"));
								}
							}
						}
					}	
					
					// Ajouter quoi qu'il arrive l'utilisateur admin
					$res = ldap_search($ds,$config['LDAPracine'],"uid=admin");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						AtacheUserBlog($id,$ds,$entryID,1);
					}
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Détacher les utilisateurs du site");
						DetacheUserBlog($id,$ds,"(&(memberUid=%userid%)(gidNumber=".$db1->f("idsynchro").")(type=*))");
					}
					
				break;				
			}
	
		} // fin du else
		
		AfficheLigne("");
		AfficheLigne("");
		AfficheLigne("");
	
	}	// fin du foreach


    // Suppression des utilisateurs sans blog
    if($fgpurgefin) {
	    AfficheTitre("Suppression des utilisateurs sans blog");
        $tbusers = $wpdb->get_results("SELECT ID FROM wp_users");
	    foreach($tbusers as $users) {
	        foreach( (array) $users as $user) {
	            foreach((array) $user as $value) {
	                if(count(get_blogs_of_user($value))==0) {
                        $deluser = get_user_by( 'ID', $value );
                        AfficheLigne($deluser->user_login." = Supprimé");
                        wp_delete_user($value,$admin_id);
					    $wpdb->query("DELETE FROM $wpdb->users WHERE ID = $value");
					    $wpdb->query("DELETE FROM $wpdb->usermeta WHERE user_id = $value");                    
                        
        	        }
                }
            }
        }	
    }

    // Ajouter la metadata wpDirAuthFlag à l'ensemble des utilisateurs afin qu'il soit authentifié via le ldap
    $tbusers = $wpdb->get_results("SELECT ID FROM wp_users");
    foreach($tbusers as $users) {
        foreach( (array) $users as $user) {
            foreach((array) $user as $value) {
                $tbmeta=$wpdb->get_results("SELECT * FROM wp_usermeta WHERE user_id=$value AND meta_key='wpDirAuthFlag'");
                if(count($tbmeta)==0) {
                    $wpdb->query("INSERT INTO wp_usermeta (user_id,meta_key,meta_value) VALUES($value,'wpDirAuthFlag','true')");
                }
            }
        }
    }
	
?>



